function cumulativeOffset(element) {
    var top = 0;
    var left = 0;
    do {
        top += element.offsetTop  || 0;
        left += element.offsetLeft || 0;
        element = element.offsetParent;
    } while(element);

    return {
        top: top,
        left: left
    };
};

function showHelp(element, helptext, nextFunction, cancelFunction, onTop, helpWidth, onLoad)  {

	// pages that have "tabs" or elements that are not always displayed, should skip the help
	// this makes sure that we skip hidden elements
	if (!element.is(':visible')) {
		nextFunction();
		return
	}


	// help already being displayed 
	if (document.getElementById("_divControl"))
		return;
	

	let pad = 10;
	var textBox = 400;

	if (helpWidth)
		textBox = helpWidth;

	let bb = element[0].getBoundingClientRect();

	let topLeft = cumulativeOffset(element[0]);

	bb.x = topLeft.left;
	bb.y = topLeft.top;

	let posX = bb.x - pad;
	let posY = bb.y - pad;
	let posW = bb.width + pad*2;
	let posH = bb.height + pad*2;

	let divControl = $(document.createElement('div'));
	let divHelp = $(document.createElement('div'));
	let buttonNext = $(document.createElement('button'));
	let buttonCancel = $(document.createElement('button'));
	let buttonsDiv = $(document.createElement('div'));

	divControl[0].setAttribute("id", "_divControl");


	divControl.addClass('helpItem');
	divHelp.addClass('helpItem');

	divControl.css('top',posY + 'px');
	divControl.css('left',posX + 'px');
	divControl.css('width',posW + 'px');
	divControl.css('height',posH + 'px');
	divControl.css('position','absolute');


	divHelp.css('top',posY + posH + 2*pad+'px');
	divHelp.css('left',posX + 'px');
	divHelp.css('width',textBox + 'px');
	divHelp.css('background-color','rgba(200,200,250,0.95)');
	divHelp.css('padding','5px 5px 5px 5px');
	divHelp.css('border','none');
	divHelp.html(helptext);
//	divHelp.css('font', '20px Helvetica sans-serif');



	buttonsDiv.css('position','absolute');
	buttonsDiv.css('z-index',10000+1);
	buttonsDiv.css('top',(posY + posH + 2*pad) + 'px');
	buttonsDiv.css('left',(posX + textBox + 2*pad) + 'px');
	buttonsDiv.css('width','100px');


	buttonNext.addClass('bt');
	buttonNext.addClass('btNext');
	buttonNext.html('Next');
	buttonNext[0].onclick = (e) => { e.stopPropagation(); masterDiv.remove(); nextFunction(); };
	buttonNext[0].onkeypress = (e) => { if (e.key == "Escape") cancelFunction(); };


	buttonCancel.addClass('bt');
	buttonCancel.addClass('btCancel');
	buttonCancel.html('Cancel');
	buttonCancel[0].onclick = (e) => { e.stopPropagation(); masterDiv.remove(); cancelFunction(); };




	let masterDiv = $(document.createElement('div'));
	masterDiv.append(divControl);
	masterDiv.append(divHelp);
	masterDiv.append(buttonsDiv);
	buttonsDiv.append(buttonNext);
	buttonsDiv.append(buttonCancel);

	$('body').append(masterDiv);

	if (onTop == 1) {
		buttonsDiv.css('top',(posY - divHelp.height() - 2*pad)+'px');
		divHelp.css('top',(posY - divHelp.height() - 2*pad)+'px');
	}
	if (onTop == 10) {
		buttonsDiv.css('left',(posX - textBox - 2*pad + divControl.width() - buttonsDiv.width())+'px');
		buttonsDiv.css('text-align','right');
		divHelp.css('left',   (posX - textBox - pad + divControl.width())+'px');
	}


	buttonNext.focus();


	if ((onLoad != undefined) && (onLoad != null)) {
		onLoad();
	}

	return masterDiv;
}







/*

.helpItem {
}

</style>


</head>

<body>


<div id="help1" style="position: absolute; top: 70px; left: 5px; width: 840px; height: 180px; ">

  <div class="helpItem" style=""></div>

  <div class="helpItem"  style="padding: 5px 5px 5px 5px; position: absolute; top: 60px; left: 10px; z-index: 10000; background-color: white;">
  dfljhdfkgjhfdgjk
</div>
*/